#define SIZ_BUF       8000	        // Keyboard buffer size
#define SM_SIZ_BUF     500              // Special aux buffer size
#define ID_LENGTH	20		// Max length for user selcal 
#define SELCAL_LENGTH	20		// Max length for remote selcal
#define WRU_LENGTH	80		// Max length for remote selcal
#define LOGFILENAME_LENGTH 40		// Max logfilename length
#define DEFAULT_STATS	0		// Stats display is off
#define SCROLLMAX 100			// Scroll back max lines
#define SCROLCOLS  80			// column width of scroll back buffer
 
#define DEFAULT_TXDELAY 30              // default tx delay
#define DEFAULT_CDDELAY  5              // default tx delay
#define DEFAULT_TIMING   0x3E80		// default timing sequence
#define DEFAULT_BOUNDARY 20		// Rx/Tx display boundary
#define DEFAULT_UOS      0              // UOS off
#define DEFAULT_CASE	 0		// disable case translations
#define DEFAULT_LOGOPTION 1		// logging text to file = on
#define DEFAULT_RELY     0		// disable high reliability option
#define DEFAULT_VIDEO    1		// Use direct video calls
#define DEFAULT_FILECRLF 1		// strip CR, NL=(CR+LF)
#define DEFAULT_REFRESH  10L 		// Status refresh rate
#define DEFAULT_TIME_TYPE 0		// Use local time (set TZ=PST8)
#define GMT	 	 1		//
#define DEFAULT_DISPLAY  0		// Do not use analog tuning display
#define DEFAULT_WORD_MODE 1		// Use word mode
#define DEFAULT_MEM_ARQ   0		// Disable memory ARQ
#define DEFAULT_PRINTER	  0		// Disable printing
#define DEFAULT_RO	  0		// 1=for receive-only
#define DEFAULT_COM_PORT  1		// COM 1
#define DEFAULT_OLVL      20		// Sound out level
#define DEFAULT_ILVL      0		// Sound in  level
#define DEFAULT_AMT_MDM	  2		// AMTOR  modem
#define DEFAULT_IRQ 	  7		// Default interrupt
#define DEFAULT_COMBASE	  0x3F8		// Default COM port base
#define DEFAULT_MASKIN	  1		// Default input mask
#define DEFAULT_MASKOUT	  1		// Default output mask

#define RED              4		// red
#define GREEN	         2		// green
#define BLACK            0		// black
#define LIGHT_GRAY       7		// light gray
#define BLINK	       128              // blink attribute
#define LINE_OVERFLOW   76              // abs max characters on a line
#define MAX_LINE        68              // after this start looking for space
#define RX_LINE_OVERFLOW 78
#define BITSLIP        128              // max bit accumulated error bitph.
#define MAX_DELAY       50              // max allowable txdelay
//#define ID_LEN         8              // signiture length
#define MAX_BUFFERS     10              // maximum number of message buffers
#define ARQ		55              // Mode
#define STBY	        00      
#define FEC             22
#define LISN            11
#define LOGINT		5		// Set for 5 minute intervals
#define SW_INT		10		// Set for 10 minute intervals
#define MAX_COM	 	4		// COM 1-4

#define TAB		0x09
#define CTL_z		0x1A
#define SHIFT_TAB           15
#define ALT_Q               16
#define ALT_W               17
#define ALT_E               18
#define ALT_R               19
#define ALT_T               20
#define ALT_Y               21
#define ALT_U               22
#define ALT_I               23
#define ALT_O               24
#define ALT_P               25
#define ALT_A               30
#define ALT_S               31
#define ALT_D               32
#define ALT_F               33
#define ALT_G               34
#define ALT_H               35
#define ALT_J               36
#define ALT_K               37
#define ALT_L               38
#define ALT_Z               44
#define ALT_X               45
#define ALT_C               46
#define ALT_V               47
#define ALT_B               48
#define ALT_N               49
#define ALT_M               50
#define F1                  59
#define F2                  60
#define F3                  61
#define F4                  62
#define F5                  63
#define F6                  64
#define F7                  65
#define F8                  66
#define F9                  67
#define F10                 68
#define Home                71
#define UpArrow             72
#define PgUp                73
#define LeftArrow           75
#define RightArrow          77
#define End                 79
#define DownArrow           80
#define PgDn                81
#define Insert              82
#define Delete              83
#define SHIFT_F1            84
#define SHIFT_F2            85
#define SHIFT_F3            86
#define SHIFT_F4            87
#define SHIFT_F5            88
#define SHIFT_F6            89
#define SHIFT_F7            90
#define SHIFT_F8            91
#define SHIFT_F9            92
#define SHIFT_F10           93
#define CONTROL_F1          94
#define CONTROL_F2          95
#define CONTROL_F3          96
#define CONTROL_F4          97
#define CONTROL_F5          98
#define CONTROL_F6          99
#define CONTROL_F7         100
#define CONTROL_F8         101
#define CONTROL_F9         102
#define CONTROL_F10        103
#define ALT_F1             104
#define ALT_F2             105
#define ALT_F3             106
#define ALT_F4             107
#define ALT_F5             108
#define ALT_F6             109
#define ALT_F7             110
#define ALT_F8             111
#define ALT_F9             112
#define ALT_F10            113
#define CONTROL_PrtSc      114
#define CONTROL_LeftArrow  115
#define CONTROL_RightArrow 116
#define CONTROL_End        117
#define CONTROL_PgDn       118
#define CONTROL_Home       119
#define ALT_1              120
#define ALT_2              121
#define ALT_3              122
#define ALT_4              123
#define ALT_5              124
#define ALT_6              125
#define ALT_7              126
#define ALT_8              127
#define ALT_9              128
#define ALT_0              129
#define ALT_Hyphen         130
#define ALT_EQ             131
#define CONTROL_PgUp       132
#define BackSpace            8

// Header for ESC615 ASIC

// Maximum size of DSP program and data memory in bytes
#define DSP_MAX_MEM	0xc000

// Number of available IRQ and DMA channels
#define NUMIRQS  	7
#define NUMDMAS  	6

// IO port address offsets from pssbase
#define PSS_CONFIG    	0x0010
#define WSS_CONFIG    	0x0012
#define SB_CONFIG     	0x0014
#define CD_CONFIG 	0x0016
#define MIDI_CONFIG   	0x0018

// Configuration register bit equates
#define ADDRMASK  	0xffc0
#define PORTMASK4	0xffc0
#define PORTMASK16	0xff00

#define NOIRQ		0x0000
#define IRQ3		0x0008
#define IRQ5		0x0010
#define IRQ7		0x0018
#define IRQ9		0x0020
#define IRQ10		0x0028
#define IRQ11       	0x0030
#define IRQ12		0x0038
#define IRQMASK		0x0038

#define NODMA		0x0000
#define DMA0		0x0001
#define DMA1		0x0002
#define DMA3		0x0003
#define DMA5		0x0005
#define DMA6		0x0006
#define DMA7		0x0007
#define DMAMASK		0x0007		

// ESC614 PSS Configuration register bit equates
#define GAME		0x0400
#define IRQSRC		0x0200
#define IRQ		0x0100
#define DMASRC		0x0080
#define DMA		0x0040

// SB (SoundBlaster) register address offsets from SB base address
#define SB_PCRESET	0x0006
#define SB_PCWSTATUS	0x000C
#define SB_PCRSTATUS	0x000E
#define SB_PCRDATA	0x000A
#define SB_PCWDATA	0x000C

// WSS register address offsets from WSS base address
#define WSS_STATUS		0x0003
#define WSS_CODECINDEXADDR	0x0004
#define WSS_CODECINDEXDATA	0x0005
#define WSS_CODECSTATUS		0x0006
#define WSS_CODECDATA		0x0007

// SM (SoundMaster) register address offsets from SB base address
#define SM_DADATA		0x000F
#define SM_ADDATA		0x000F
#define SM_TIMCNTL		0x000B

// CD-ROM Configuration register bit equates
#define CD_IRQ_POL 	0x0040 	// when bit low, 
				// PC interupt when CDROM IRQ is low

// MIDI register address offsets from MIDI base address
#define MIDI_DATA	0x0000
#define MIDI_STATUS	0x0001

// MIDI Status register bit equates
#define	MIDI_RE		0x0080
#define	MIDI_TF		0x0040

// IO port address offsets from pssbase
#define PSS_DATA      	0x0000
#define PSS_STATUS    	0x0002
#define PSS_CONTROL   	0x0002
#define PSS_ID_VERS   	0x0004
#define PSS_IRQ_ACK   	0x0004 // clears IRQ and DMA_TC status bits
#define PSS_PIO		0x001a
 
// PSS Status register bit equates
#define PSS_WE       	0x8000
#define PSS_RF       	0x4000
#define PSS_IRQ		0x2000
#define PSS_DMATC	0x1000
#define PSS_FLAG3	0x0800
#define PSS_FLAG2	0x0400

// PSS Control register bit equates
#define PSS_WEIE       	0x8000
#define PSS_RFIE       	0x4000
#define PSS_RESET	0x2000
#define PSS_FLAG1	0x1000
#define PSS_FLAG0	0x0800

// Defines and prototypes
// PSS DSP Debug code equates

#define READ_DATA_CMD   0xd0
#define WRITE_DATA_CMD  0xd1
#define READ_PROG_CMD   0xd2
#define WRITE_PROG_CMD  0xd3
#define PROG_ID_CMD     0xd4  
#define SOFTRESET_CMD   0xfe
#define LOAD_IMASK_CMD	0x02  

#define IRQ3_VECTOR    	0x000c
#define IRQ5_VECTOR    	0x0014
#define IRQ7_VECTOR    	0x001c
#define IRQ9_VECTOR    	0x0024
#define IRQ10_VECTOR    0x0028
#define IRQ11_VECTOR    0x002c
#define IRQ12_VECTOR    0x0030



//--------------------------------------------------------------------------

		// Circular buffer management
class Circ_buffer
{
	char *buffr;		        // private by definition
        int  buf_size;
	int  present_size;
	char *store_at_ptr;
	char *read_from_ptr;		
public:
        Circ_buffer( int size )		// Contructor
           {
           buf_size = size;
	   present_size=0;
           buffr =  new char[size];
	   store_at_ptr = read_from_ptr = buffr;
           }
	char Read_buf();     	        // Get next character from buffer
		                        // zero on empty
        char Peek_buf();                // Same as above except no
                                        // indexes being incremented
	int Store_buf(char);		// Store character in buffer

        unsigned char Back_space();     // Remove the most recent character
                                        // from buffer if possible
        void Flush_buf();               // Reset all buffer pointers 											// zero when character not accepted

        int Present_size();             // Retrieve buffer size
};

