//    PSATOR - Library of routines for amateur radio AMTOR/PACTOR
//    Copyright (C) 1993-1995 Johan B. Forrer, KC7WW
//
//    This is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//
//  Routine to interface TOR to TORBIOS calls
//

#include <dos.h>
#include <conio.h>
#include <stdio.h>
#include <math.h>
#include "amt56def.hpp"

extern "C" int far new_io_vec(int,int,int);

int get_data()
{
union REGS xr;
//        xr.h.al = 0;
//        xr.h.ah = 3;                          // status

	xr.x.ax=new_io_vec(3<<8,0,0);

        if ((xr.h.ah&0x01)==0) return(0);
       
//        xr.h.al = 0;
//        xr.h.ah = 2;                          // Receive character
	xr.x.ax=new_io_vec(2<<8,0,0);
	return(xr.x.ax);
}

int get_data_nocheck()
{
union REGS xr;
//        xr.h.al = 0;
//        xr.h.ah = 2;                          // Receive character

	xr.x.ax=new_io_vec(2<<8,0,0);
	return(xr.x.ax);
}

int send_data(int dat)
{
union REGS xr;
//        xr.h.al = 0;
//        xr.h.ah = 3;                          // status
	xr.x.ax=new_io_vec(3<<8,0,0);
        if ((xr.h.ah&0x60)==0) return(1);
       
//        xr.h.al = (unsigned char)dat;
//        xr.h.ah = 1;                          // Send character
	new_io_vec(0x0100|dat,0,0);

	return(0);
}

int test_BIOS()                               // Check for presence of TORBIOS     
{
union REGS xr;
//        xr.h.al = 0;
//        xr.h.ah = 4;
      	xr.x.ax=new_io_vec(4<<8,0,0);
	return(xr.x.ax);
}

int _t_speedup()                             // Initialize TORBIOS
{
union REGS xr;
//        xr.h.al = 0;
//       xr.h.ah = 101;
	xr.x.ax=new_io_vec(101<<8,0,0);
	return xr.x.ax;
}

void set_control(int cntrl)                   // Direct setting control byte
{
union REGS xr;
//        xr.h.al = 0;
//        xr.h.ah = 103;
//        xr.x.bx = cntrl;
	  new_io_vec(103<<8,cntrl,0);
}

void set_txdelay(int del)                     // Set txdelay
{
union REGS xr;
//        xr.h.al = 0;
//        xr.h.ah = 104;
//        xr.x.bx = del;
	new_io_vec(104<<8,del,0);
}

void set_txmask(int mask)                     // Set txmask
{
	new_io_vec(105<<8,mask,0);
}

void set_rxmask(int mask)                     // Set rxmask
{
	new_io_vec(106<<8,mask,0);
}

void set_cd_delay(int del)                    // Set cd delay
{
union REGS xr;
//        xr.h.al = 0;
//        xr.h.ah = 132;
//        xr.x.bx = del;
	new_io_vec(132<<8,del,0);
}

int  get_status(void)                        // Get status byte directly
{
union REGS xr;
//        xr.h.al = 0;
//        xr.h.ah = 107;
	xr.x.ax=new_io_vec(107<<8,0,0);
	return xr.x.ax;
}

int  get_phase_err(void)                     // Get phase error
{
union REGS xr;
//        xr.h.al = 0;
//        xr.h.ah = 108;
	xr.x.ax=new_io_vec(108<<8,0,0);
	return xr.x.ax;
}

int  get_BKRX(void)                          // Get timing values
{
union REGS xr;
//        xr.h.al = 0;
//        xr.h.ah = 110;
	xr.x.ax=new_io_vec(110<<8,0,0);
	return xr.x.ax;
}

int  get_debug1(void)                       // not used  (CTRX)
{
union REGS xr;
//        xr.h.al = 0;
//        xr.h.ah = 109;
	xr.x.ax=new_io_vec(109<<8,0,0);
	return xr.x.ax;
}

unsigned int  get_cases(void)              // returns RX/TX case
{
union REGS xr;
//        xr.h.al = 0;
//        xr.h.ah = 116;
	xr.x.ax=new_io_vec(116<<8,0,0);
	return xr.x.ax;
}

int  get_rxdta(void)                       // get received byte directly
{
union REGS xr;
//        xr.h.al = 0;
//        xr.h.ah = 111;
	xr.x.ax=new_io_vec(111<<8,0,0);
	return xr.x.ax;
}

int  output_txdta(int dat)                 // output data byte directly
{
union REGS xr;
//        xr.h.al = 0;
//        xr.h.ah = 112;
//        xr.x.bx = dat;
	xr.x.ax=new_io_vec(112<<8,dat,0);
	return xr.x.ax;
}

void force_ltrs(void)                      // Force LTRS directly
{
union REGS xr;
//        xr.h.al = 0;
//        xr.h.ah = 113;
	new_io_vec(113<<8,0,0);
}

void set_SELCAL(char * ptr)                // Set up selcal directly
{
//union REGS xr;
//        xr.h.al = 0;
//        xr.h.ah = 114;
//        xr.h.bh = *ptr++;
//        xr.h.bl = *ptr++;
//        xr.h.dh = *ptr++;
//        xr.h.dl = *ptr;
unsigned int a,b;
	a=*ptr++;
	a=(a<<8)|(*ptr++);
	b=*ptr++;
	b=(b<<8)|(*ptr);
	new_io_vec(114<<8,a,b);
}

void set_IDENT(char * ptr)                 // Set up id directly
{
//union REGS xr;
//        xr.h.al = 0;
//        xr.h.ah = 115;
//        xr.h.bh = *ptr++;
//        xr.h.bl = *ptr++;
//        xr.h.dh = *ptr++;
//        xr.h.dl = *ptr;
unsigned int a,b;
	a=*ptr++;
	a=(a<<8)|(*ptr++);
	b=*ptr++;
	b=(b<<8)|(*ptr);
	new_io_vec(115<<8,a,b);
}

void close_port(void)                      // Restore int14
{
union REGS xr;
//        xr.h.al = 0;
//        xr.h.ah = 117;
	new_io_vec(117<<8,0,0);
}

void set_timing(int value)    // Load timing
{
}

void flush_rxbuffer()    		// Flush 64 byte receive buffer
{
union REGS xr;
//        xr.h.al = 0;
//        xr.h.ah = 119;
	new_io_vec(119<<8,0,0);
}

void send_command(unsigned char command)   // Send character without 
{                                          // preliminary status check
union REGS xr;
//        xr.h.al = command;
//        xr.h.ah = 1;                       // Send character
	new_io_vec(0x0100|(unsigned int)command,0,0);
}

void set_UL_case(int case_value)    // Set upper/lower case translate
{
union REGS xr;
//        xr.h.al = 0;
//        xr.h.ah = 120;
//        xr.x.bx = case_value;
	new_io_vec(120<<8,case_value,0);
}

void set_reliability(int rely_value)    // Set higher reliability option
{
union REGS xr;
//        xr.h.al = 0;
//        xr.h.ah = 121;
//        xr.x.bx = rely_value;
	new_io_vec(121,rely_value,0);
}

void set_raw_mode(int mode)    		// Set raw mode
{
union REGS xr;
//        xr.h.al = 0;
//        xr.h.ah = 122;
//        xr.x.bx = mode;
	new_io_vec(122,mode,0);
}

void get_tuning_data(int *t1, int *t2)  // Get tuning data
{
int sig;
	sig=new_io_vec(123<<8,0,0);
	*t1=(sig>>8);
	sig=new_io_vec(124<<8,0,0);
	*t2=(sig>>8);
}

void set_mem_ARQ(int mem_arq) 		// Enable/disable memory arq
{
union REGS xr;
//        xr.h.al = 0;
//        xr.h.ah = 127;
//        xr.x.bx = mem_arq;
	new_io_vec(127<<8,mem_arq,0);
}

int get_RQ(void) 			// Get RQ count
{
union REGS xr;
//        xr.h.al = 0;
//        xr.h.ah = 128;
	xr.x.ax=new_io_vec(128<<8,0,0);
        return xr.x.ax;
}

int get_ER1(void) 			// Get ERROR count
{
union REGS xr;
//        xr.h.al = 0;
//        xr.h.ah = 129;
	xr.x.ax=new_io_vec(129<<8,0,0);
        return xr.x.ax;
}

int get_ER2(void) 			// get Error count fixed up by MARQ
{
union REGS xr;
//        xr.h.al = 0;
//        xr.h.ah = 130;
	xr.x.ax=new_io_vec(130<<8,0,0);
        return xr.x.ax;
}

void clear_counts(void) 		// clear all counts
{
union REGS xr;
//        xr.h.al = 0;
//        xr.h.ah = 131;
	new_io_vec(131<<8,0,0);
}

int get_RTS(void) 		// get RTS status
{
union REGS xr;
//        xr.h.al = 0;
//        xr.h.ah = 133;
	xr.x.ax=new_io_vec(133<<8,0,0);
	return xr.x.ax;
}

int get_MS(void) 		// get MASTER/SLAVE STATUS
{
union REGS xr;
//        xr.h.al = 0;
//        xr.h.ah = 134;
	xr.x.ax=new_io_vec(134<<8,0,0);
	return xr.x.ax;
}

int  get_debug2(void)                          // Debug hook 2
{
union REGS xr;
//        xr.h.al = 0;
//        xr.h.ah = 200;
	xr.x.ax=new_io_vec(200<<8,0,0);
	return xr.x.ax;
}

int  get_debug3(void)                          // Debug hook 3
{
union REGS xr;
//        xr.h.al = 0;
//        xr.h.ah = 201;
	xr.x.ax=new_io_vec(201<<8,0,0);
	return xr.x.ax;
}

