//    PSATOR - Library of routines for amateur radio AMTOR/PACTOR
//    Copyright (C) 1993-1995 Johan B. Forrer, KC7WW
//
//    This is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//
// This module handles all AMTOR
//
//---------------------------------------------------------------------------
#include <stdio.h>
#include <dos.h>
#include <ctype.h> 
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <alloc.h>
#include <string.h>
#include <time.h>
#include <bios.h>    
#include <mem.h>

#include "amt56def.hpp"                   // defines 
#include "amt56bios.hpp"
#include "amt56ext.hpp"			// External defs

extern void display_cursor(void);       // For displaying cursor
extern void terminate_prog(char *);		// Catastrophic error handler
extern void dosshell_cmd(void);		// dos shell command
extern void logshell_cmd(void);		// log program shell command
extern void pactor_program(void);	// Pactor program
extern void modem_program(int);	// Modem control program
extern void packet_program(void);	// Baycom packet program
extern void store_keyboard_input(Circ_buffer *, char);
extern void enter_selcal(void); 
extern void buffers_menu(Circ_buffer *); // show & select text buffer
extern void files_menu(Circ_buffer *, Circ_buffer *);	// enter filename for transmission
extern void loop_menu(Circ_buffer *, Circ_buffer *);	// looped transmission
extern void show_help(void);		 // Show help
extern void sig_analyse(int);		 // Analyse signal
extern void buffer_load(int, Circ_buffer*);	// Load special buffer via ALT-x key
extern void terminate_prog(char *);	 // Catastrophic error handler
extern void display_cursor(void);        // For displaying cursor

//---------------------------------------------------------------------------
// Check for data received from AMTOR
//---------------------------------------------------------------------------
void check_AMT_BD_ASCII_input()
{

void update_scroll(char);

int data_received, i;
char ch, time_string[80];

//---------------------------------------------------------------------------
// 		   Handle echoed data first
// This type of data will always contain its own line length control.
// We use 7Fh as the "no character" symbol, is there such a symbol ???
//---------------------------------------------------------------------------

	if(echo_char!=0x7F) {
         	current_window = activate_window(2);
		if(echo_char!= 0x0) cprintf("\b \b"); // remove old cursor
		ch=echo_char;
		echo_char=0x7F; 		// to avoid an endleess loop

// If upper/and lowercase enabled, handle extended characters
	     if((UL_case)&&(prev_echo==(char)0x0)) switch(ch)
	     		{
	     		case '-': ch='_';
	     		     break;
	     		case ':': ch=';';
	     		     break;
	     		case '%': ch='`';
	     		     break;
	     		case '@': ch='}';
 	     		     break;
	     		case '#': ch='{';
	     		     break;
	     		case '(': ch='[';
	     		     break;
	     		case ')': ch=']';
	     		     break;
	     		case '.': ch='>';
	     		     break;
	     		case ',': ch='<';
	     		     break;
	     		case '9': ch='~';
	     		     break;
	     		case '1': ch='!';
	     		     break;
	     		case '4': ch='$';
	     		     break;
	     		case (char)0x27: ch='"';
	     		     break;
	     		case '7': ch='&';
	     		     break;
	     		case '=': ch='|';
	     		     break;
	     		case '/': ch=(char)0x5C;
			     break;	      		
	     		case '6': ch='^';
	     		     break;
	     		}

 // Strip out NL characters for display
	    	if ((ch!='\n')&&(ch!=(char)0x0)) {
			textattr(0x7F&(c_ECHOCOLOR+(c_BGCOLOR<<4)));
         		current_window = activate_window(2);
			if(wherex()>=RX_LINE_OVERFLOW) {
				cprintf("\r\n");
				clreol();
				if(Log_option)fprintf(logfile,"\r\n");
				if(Printer)fprintf(stdprn,"\r\n");
				update_scroll('\n');
				}
			cprintf("%c",ch);
			fprintf(scrollfile,"%c",0x80|ch); // note bit7 is high
			textcolor(c_CHCOLOR);
			textbackground(c_BGCOLOR);
			if(Log_option)fprintf(logfile,"%c",ch);
			if(Printer)fprintf(stdprn,"%c",ch);
			}
// However, pass NL to logfile                         
// CR implies CR/LF for display purposes
	    	if(ch=='\r') {
			cprintf("\n");
		    	update_scroll('\n');
			clreol();
			if(Log_option)fprintf(logfile,"\n");
			if(Printer)fprintf(stdprn,"\n");
			}
		if(ch!=0x0) cprintf("");     // show cursor
		prev_echo=ch;
		return;
		}

//---------------------------------------------------------------------------
// Now look at data received through amtor
//---------------------------------------------------------------------------   
   data_received = get_data();	  	// use the bios call to use
   if (data_received != 0)		// 64 deep buffer rather than
        {				// get_rxdta which is unbuffered.
        current_window = activate_window(2);
        ch = (char)data_received;
	if(ch=='$') ch='';		// Display the WRU character

	cprintf("\b \b");	 	// remove old cursor
		
// If we are in mode L and our own selcal is captured, force STANDBY mode
	for(i=0;i<10;i++) L_selcal[i]=L_selcal[i+1];
	L_selcal[10]=toupper(ch); 
	if(((sys_stat&0x18)==0)&&      	//  = ARQ RX =
	    	(L_selcal[0]==' ')&&(L_selcal[5]==' ')&&(L_selcal[10]==' ')&&
		(L_selcal[1]==ident[0])&&(L_selcal[2]==ident[1])&&
	    	(L_selcal[3]==ident[2])&&(L_selcal[4]==ident[3])&&
	    	(L_selcal[6]==ident[0])&&(L_selcal[7]==ident[1])&&
	    	(L_selcal[8]==ident[2])&&(L_selcal[9]==ident[3]))
			{
             		set_control(0x06); // Force a SBY
			}

// Raw data mode will do a hex dump of ITA2 data bytes
	if (!Raw_mode)
	     {
// If upper/and lowercase enabled, handle extended characters
	     if((UL_case)&&(L_selcal[9]==(char)0x0)) switch(ch)
	     		{
	     		case '-': ch='_';
	     		     break;
	     		case ':': ch=';';
	     		     break;
	     		case '%': ch='`';
	     		     break;
	     		case '@': ch='}';
 	     		     break;
	     		case '#': ch='{';
	     		     break;
	     		case '(': ch='[';
	     		     break;
	     		case ')': ch=']';
	     		     break;
	     		case '.': ch='>';
	     		     break;
	     		case ',': ch='<';
	     		     break;
	     		case '9': ch='~';
	     		     break;
	     		case '1': ch='!';
	     		     break;
	     		case '4': ch='$';
	     		     break;
	     		case (char)0x27: ch='"';
	     		     break;
	     		case '7': ch='&';
	     		     break;
	     		case '=': ch='|';
	     		     break;
	     		case '/': ch=(char)0x5C;
			     break;	      		
	     		case '6': ch='^';
	     		     break;
	     		}
	
	     if (ch!='\n')   // Strip out NL characters for display
		if(ch!=(char)0x0)
			{
			cprintf("%c",ch);
			fprintf(scrollfile,"%c",ch);
			if(Log_option)fprintf(logfile,"%c",ch);
			if(Printer)fprintf(stdprn,"%c",ch);
			}

// However, pass NL to logfile                         
// CR implies CR/LF for display purposes
	     if(ch=='\r') {
		cprintf("\n");
		clreol();
		update_scroll('\n');
		if(Log_option)fprintf(logfile,"\n");
		if(Printer)fprintf(stdprn,"\n");
		}

// Time stamps inserted into log at "LOGINT" minute intervals	  
	     time(&bintime);  
	     if((Log_option)&&(difftime(bintime,previous_time)>LOGINT*60)) {
// if mode is NOT STBY and received CR
		if(((sys_stat&0x07)!=06)&&(ch=='\r')) {	
			time(&previous_time);
			if(Time_Type!=GMT) curtime=localtime(&bintime); 	
			else curtime=gmtime(&bintime); 	// UTC
			sprintf(time_string,"[[%s]] ", asctime(curtime));
			i=0;
			while (time_string[i]!='\0') {
				if(!((time_string[i]=='\r')||(time_string[i]=='\n')))
					fprintf(logfile,"%c",time_string[i]);				
				i++;
				}
			if(Stats)fprintf(logfile," R:%d E:%d/%d ", 
				RQ_count, ER1_count, ER2_count);
			}
		}	

// Check for WRU (received '' whilst in ARQ mode)
// Note: Mode is the overall state as far as the user keyboard is concerned.
//       sys_stat is the actual state as far as TORBIOS is concerned.
//       These two versions of state is necessary as: 
//               a) Mode cannot detect  when i.e. a slave sync happens,
//                  or FEC sync on receive occurs.
//               b) sys_state doesnt know the difference between ARQ and
//                  LISN mode.                                       

	     sys_stat = get_status();	      		// get status data
             if ((ch=='')&&((Mode==ARQ)||(Mode==STBY))) 
		send_wru(&Special_buffer);

// Check and handle unshift-on-space
	     if (((char)data_received==' ')&&(UOS)) force_ltrs();
	     }

// Print and log in raw data mode
	if(Raw_mode) {     
		ch=ch&0x1F;  // Strip off extra bits
	 	cprintf("%X%X ",(unsigned char)ch>>4, (unsigned char)ch&0xF);
		fprintf(scrollfile,"%X%X ",(unsigned char)ch>>4, (unsigned char)ch&0xF);
		if(Log_option)fprintf(logfile,"%X%X ",
                              (unsigned char)ch>>4, (unsigned char)ch&0xF);

        	current_window = activate_window(2);
		if(wherex()>=79) {	// handle wrap round case
			cprintf("\r\n");
			update_scroll('\n');
			if(Log_option)fprintf(logfile,"\r\n");
			clreol();
			}
		}

        current_window = activate_window(2);
        if(wherex()>=RX_LINE_OVERFLOW)	// handle wrap round
	   if((ch==' ')||(wherex()>=MAX_LINE)) {
		cprintf("\r\n");
		update_scroll('\n');
		if(Log_option)fprintf(logfile,"\r\n");
		if(Printer)fprintf(stdprn,"\r\n");
		clreol();
		}

	cprintf("");     // show cursor
        }	    


}

//---------------------------------------------------------------------------
// Check if there is data to be transmitted to the AMTOR unit
// NOTE: if on the first try the response is not zero, this
// may be because the AMTOR unit is not ready to accept the
// data or, the character to be sent has caused a LTR or FIG
// shift to be sent ahead - in which case the character will be 
// accepted on the next round.
// Note that the order of priority is: Keyboard buffer highest, Special
// buffer lower
//---------------------------------------------------------------------------
void check_AMT_BD_ASCII_buffs()
{

int tx_status, x, y;
char ch, tst_char[8];
static char ch_1;
//
// Special bandaid for situations where we gotten behind in word mode
//
	if((Keyboard_buffer.Peek_buf()!=(char)0xFF)&&(entered_space<=0)&&
		((last_entered_char==' ')||
		((second_to_last=='+')&&(last_entered_char=='?'))) ) 
		entered_space++;	

//
// Special buffer must be emptied before keyboard buffer
// used in conjunction with WRU
//
	if ((ch = Special_buffer.Peek_buf()) != (char)0xFF)
         	{                                   
         	tx_status = output_txdta( (int)ch );
         	if (tx_status==0) {
			Special_buffer.Read_buf();
			echo_char=ch;	// echo the character now
			}
		else ch=ch; // dummy
         	}

// Take care of Keyboard entries                  
//
	else {   
	  if((entered_space&&Word_Mode)||(!Word_Mode)) {
         	if ((ch = Keyboard_buffer.Peek_buf()) != (char)0xFF)
                	{ 
                	tx_status = output_txdta( (int)ch );
                	if (tx_status==0) 
				{
				Keyboard_buffer.Read_buf();
				echo_char=ch;	// echo the character now

// Check for word-mode 'push into buffer' phrases, and acknowledge
// that they have been taken care of.
				if(Word_Mode) {
				  if((ch==' ')||	    // space, LF and +?
				     (ch=='\n')||(ch=='\r')||(ch=='$')||
				     ((ch=='?')&&(ch_1=='+'))) entered_space--;
				  if(entered_space<0) entered_space=0;
				  }
				ch_1=ch;
				}
                	}
		}
	  }
}

//---------------------------------------------------------------------------
// Check keyboard for input
//---------------------------------------------------------------------------
char check_AMT_BD_ASCII_keyboard()
{
void init_scrolling();

char ch, time_string[80], *ptr;
static char ch_kb_1;
int i;
extern int Mask_in;

   if (kbhit()) 
         {
         current_window = activate_window(3);
         ch = getch();
         if ( ch == 0)                 /* 0 code */
            {
            ch = getch();
            switch ( ch )
               {
						// F1 - INITIATE FEC
               case F1:	if(Receive_only) break;
			set_control(0x04);
			Mode=FEC;
                        break;  

               case F2: if(Receive_only) break; // F2 - INITIATE ARQ
			set_control(0x03);  
                        Mode=ARQ;       
                        break;  

               case F3: 				// F3 - FORCE OVER
			set_control(0x01);
			break;

							// F4 - QRT
               case F4:	
			set_control(0x02); 	// set Quit flag
                        Mode=STBY;		// (All modes)
                        break;

               case F5: 				// F5 - timestamp 
							//  to log file
			if(Log_option) {
			  time(&bintime);	// get time in seconds since 00:00:00 UTC,1/1/70  
			  if(Time_Type!=GMT) curtime=localtime(&bintime); // convert to local time	
			  else curtime=gmtime(&bintime); 	// UTC
			  sprintf(time_string,"---<%s>---->Logged at: %s", 
				 selcal, asctime(curtime));
			  i=0;	           // Strip out extra CR/LF
			  while (time_string[i]!='\0') {
				if(!((time_string[i]=='\r')||(time_string[i]=='\n')))
					fprintf(logfile,"%c",time_string[i]);				
				i++;
				}
			  if(Stats) fprintf(logfile," R:%d E:%d/%d ",
					RQ_count, ER1_count, ER2_count);
			  fprintf(logfile,"\r\n");
			  flushall();  // Makes sure all files are updated				
		          }
			break; 
               case F6: set_control(0x05);		// F6 - LISTEN
			Mode=LISN;
            		break;
               case F7:                                 // F7 - Flush input bufr
                        send_command((unsigned char)0x18);
                        Keyboard_buffer.Flush_buf();   
                        Special_buffer.Flush_buf();
                        gotoxy(1,1);
                        clrscr(); 
                        display_cursor();
			entered_space=0;  		// reset word mode
			set_UL_case(UL_case);		// also reset the cases
                        break;  
               case F8: 				// F8 - DOSSHELL
			if(Log_option) {
			  time(&bintime);   
			  if(Time_Type!=GMT) curtime=localtime(&bintime); 
			  else curtime=gmtime(&bintime); 	// UTC
			  sprintf(time_string,"---->Shell to DOS at: %s", asctime(curtime));	
			  fprintf(logfile,"\r\n");
			  i=0;	           // Strip out extra CR/LF
			  while (time_string[i]!='\0') {
				if(!((time_string[i]=='\r')||(time_string[i]=='\n')))
					fprintf(logfile,"%c",time_string[i]);				
				i++;
				}
			  fclose(logfile);
		          }
			dosshell_cmd();
			if(Log_option) {
			  if((logfile=fopen(logfilename,"a"))==NULL)
                	    terminate_prog("Fopen - cannot re-open log file");
			  time(&bintime);   
			  if(Time_Type!=GMT) curtime=localtime(&bintime); 
			  else curtime=gmtime(&bintime); 	// UTC
			  sprintf(time_string,"---->Return from DOS at: %s", asctime(curtime));	
			  i=0;	           // Strip out extra CR/LF
			  while (time_string[i]!='\0') {
				if(!((time_string[i]=='\r')||(time_string[i]=='\n')))
					fprintf(logfile,"%c",time_string[i]);				
				i++;
				}
			  fprintf(logfile,"\r\n");
		          }
			break;            
               case F9: break;			        // F9 - Not used

               case F10:				// F10 - FORCE STBY
			set_control(0x06);
			Mode=STBY;
			qrt_flag=0;
			break;

               case SHIFT_F7:  current_window = activate_window(2); // SHIFT F7 - Flush 
                        gotoxy(1,1);                    //    AMTOR display
                        clrscr(); 
                        break;
		case End:                               // enter +? in buffer
			store_keyboard_input(&Keyboard_buffer,'+');  
			store_keyboard_input(&Keyboard_buffer,'?');  
			entered_space++;  // to allow word mode to recog
                        break;
		case Insert:                            // mycall de hiscall
                        ptr=&selcal[5];
                        do {store_keyboard_input(&Keyboard_buffer,*ptr++);}  
			                                while (*ptr!='\0');
		        store_keyboard_input(&Keyboard_buffer,' ');
			store_keyboard_input(&Keyboard_buffer,'D');
			store_keyboard_input(&Keyboard_buffer,'E');
		        store_keyboard_input(&Keyboard_buffer,' ');
                        ptr=&ident[5];
			do {store_keyboard_input(&Keyboard_buffer,*ptr++);}  
			                                while (*ptr!='\0');
		        store_keyboard_input(&Keyboard_buffer,' ');
			entered_space+=3;  // for word mode
                        break;
                case Delete: force_ltrs();		// Del - Force LTRS
			set_UL_case(UL_case);           // Reset case to upper
			break;

		
		case PgUp:
		case PgDn:
		case DownArrow:
                case UpArrow: init_scrolling();		// Buffer Scrolling
			break;

		case ALT_A:
			break;

                case ALT_B:                             // Enter text buffer
                        buffers_menu(&Keyboard_buffer);
                        break;

                case ALT_C:                             // Enter ARQ selcal
                        enter_selcal();                 // !!initiate ARQ!!
			set_control(0x03);  
                        Mode=ARQ;       
                        break;  

                case ALT_D:
                        break;

                case ALT_F:                             // File for trans-
							//    mission
                        files_menu(&Special_buffer, &Keyboard_buffer);	
                        break;

		case ALT_H:				// Help required
			show_help();
			if(kbhit()) getch();		// ignore response
			break;

		case ALT_I: 	 			// Toggle input mask
			Mask_in^=0x80;
			set_rxmask(Mask_in);
			if(Mask_toggle) Mask_toggle=0; // Toggle goblin
			else            Mask_toggle=1;
			break;

		case ALT_L:
			break;

		case ALT_M:
			break;

		case ALT_O:				// Toggle printer
			if(Printer==0) Printer=1;
			else           Printer=0;
			break;

		case ALT_P:				// Pactor
			pactor_program();
			break;

                case ALT_R:                             // Enter remote selcal
                        enter_selcal();             
                        break;				// Speedup buffer loads

                case ALT_S:                             // Looped File
							// transmission
                        loop_menu(&Special_buffer, &Keyboard_buffer);	
                        break;

                case ALT_T:                             // Enter stimestamp
			time(&bintime);   		// in keyboard buffer
			curtime=gmtime(&bintime); 	// UTC
			sprintf(time_string," %2d:%2d UTC %d/%d/%d ", 
		          curtime->tm_hour, curtime->tm_min, curtime->tm_mon+1,
		          curtime->tm_mday, curtime->tm_year);   
			if(time_string[1]==' ') time_string[1]='0';
			if(time_string[4]==' ') time_string[4]='0';
                        ptr=time_string;
                        do {store_keyboard_input(&Keyboard_buffer,*ptr++);}  
			                                while (*ptr!='\0');
			entered_space+=4;
                        break;
							// send a WRU
		case ALT_W: if(Receive_only) break;
			Keyboard_buffer.Store_buf('$');
			entered_space++;
		  	break;

		case ALT_X: ch=0xFF;   	// Alternate quit route
		  	break;

		case ALT_Y:
			break;

		case ALT_1: buffer_load(1,&Keyboard_buffer);
			break;
		case ALT_2: buffer_load(2,&Keyboard_buffer);
			break;
		case ALT_3: buffer_load(3,&Keyboard_buffer);
			break;
		case ALT_4: buffer_load(4,&Keyboard_buffer);
			break;
		case ALT_5: buffer_load(5,&Keyboard_buffer);
			break;
		case ALT_6: buffer_load(6,&Keyboard_buffer);
			break;
		case ALT_7: buffer_load(7,&Keyboard_buffer);
			break;
		case ALT_8: buffer_load(8,&Keyboard_buffer);
			break;
		case ALT_9: buffer_load(9,&Keyboard_buffer);
			break;
		case CONTROL_Home: 	  // Toggle Raw mode
         		current_window = activate_window(2);
			cprintf("\r\n");
			if(Raw_mode==0) 
				{
				set_raw_mode(1);
				Raw_mode=1;
				}
			else	{
				set_raw_mode(0);
				Raw_mode=0;
				}
			break;
               }
            }
         else 
            {
            current_window = activate_window(3);
            switch (ch)
               {
               case 0x1B: break;                // ESC                    
/* 
 * Default, save character in input buffer
 * and update word mode variables
 */
               default:  
			store_keyboard_input(&Keyboard_buffer,ch);
			if((ch==' ')||	   // detect space, LF, +? 
			   ((ch=='?')&&(ch_kb_1=='+'))) entered_space++;
			if(ch=='\r')entered_space++; // CR+LF
			ch_kb_1=ch;
               }
            }

	 return ch;
         }         /* end kbhit         */
	 else return (char)0;

}

//---------------------------------------------------------------------------
//
// Extend ASCII character and save character in indicated buffer
//
void extend_ascii(Circ_buffer *kb_ptr, char ch)
{

	if(UL_case)
		{
		switch(ch)
			{
			case '_': kb_ptr->Store_buf((char)0x0);
			     kb_ptr->Store_buf('-');
			     break;
			case ';': kb_ptr->Store_buf((char)0x0);
			     kb_ptr->Store_buf(':');
			     break;
			case '`': kb_ptr->Store_buf((char)0x0);
			     kb_ptr->Store_buf('%');
			     break;
			case '}': kb_ptr->Store_buf((char)0x0);
 			     kb_ptr->Store_buf((char)0x40);
			     break;
			case '{': kb_ptr->Store_buf((char)0x0);
			     kb_ptr->Store_buf('#');
			     break;
			case '[': kb_ptr->Store_buf((char)0x0);
			     kb_ptr->Store_buf('(');
			     break;
			case ']': kb_ptr->Store_buf((char)0x0);
			     kb_ptr->Store_buf(')');
			     break;
			case '>': kb_ptr->Store_buf((char)0x0);
			     kb_ptr->Store_buf('.');
			     break;
			case '<': kb_ptr->Store_buf((char)0x0);
			     kb_ptr->Store_buf(',');
			     break;
			case '~': kb_ptr->Store_buf((char)0x0);
			     kb_ptr->Store_buf('9');
			     break;
			case '!': kb_ptr->Store_buf((char)0x0);
			     kb_ptr->Store_buf('1');
			     break;
			case '$': kb_ptr->Store_buf((char)0x0);
			     kb_ptr->Store_buf('4');
			     break;
			case '"': kb_ptr->Store_buf((char)0x0);
			     kb_ptr->Store_buf((char)0x27);
			     break;
			case '&': kb_ptr->Store_buf((char)0x0);
			     kb_ptr->Store_buf('7');
			     break;
			case '|': kb_ptr->Store_buf((char)0x0);
			     kb_ptr->Store_buf('=');
			     break;
			case (char)0x5C: kb_ptr->Store_buf((char)0x0);
			     kb_ptr->Store_buf('/');
			     break;		      		
			case '^': kb_ptr->Store_buf((char)0x0);
			     kb_ptr->Store_buf('6');
			     break;
			default: if (kb_ptr->Store_buf(ch) != 0)
					terminate_prog("Typeahead buffer is full");
			}
		}

	else	if (kb_ptr->Store_buf(ch) != 0)
			terminate_prog("Character buffer is full");

}
//--------------------------Helper functions--------------------------------
// Routine to enter characters into keyboard buffer
// Keyboard input required that CR be treated as CR\LF pair

void store_keyboard_input( Circ_buffer *kb_ptr, char ch )
{
unsigned char temp_ch;
char temp_char[7], last_ch;
int i, y;
       
// For receive-only versions
       if(Receive_only) return;

       second_to_last=last_entered_char;	
       last_entered_char=ch;
//
//  handle backspace
//
        if (ch == BackSpace)
                {
		if(kb_ptr->Present_size()==0) return;
//
// In case we have to wrap back round to the previous line
//
		if(wherex()==1){
         		current_window = activate_window(3);
	        	cprintf(" ");  // erase old cursor
			y=wherey();
			for(i=LINE_OVERFLOW;i>2;i--){
				gettext(i,y-1+window_boundary,
					    i+1,y-1+window_boundary,
					    temp_char);
				if(temp_char[0]!=' ') break;
				}
			gotoxy(i+2, y-1);
			} 

// 
// In case the back space takes us back over a "word" boundary
//
                temp_ch=kb_ptr->Back_space();
		if(temp_ch=='?') {  // "+?"
                	last_ch=kb_ptr->Back_space();
		   	if(last_ch!='+') kb_ptr->Store_buf(last_ch);
			else {
				entered_space--;
	        		cprintf(" %c%c",ch,ch); 
				temp_ch=last_ch;
				}
			}
		if (temp_ch==' ')  entered_space--;
		if (temp_ch=='\n') entered_space-=2; 
		if(entered_space<=0) entered_space=0;

// must look if there was a preceeding NULL
// if it was - two characters must be removed
// Similarly, if CR\LF is encountered, 2 characters need to be
// removed

		if(temp_ch!=(unsigned char)0xFF)
	           {
                   temp_ch=kb_ptr->Back_space();
		   if(temp_ch!=(unsigned char)0xFF)
                     {
		     if((temp_ch!=(char)0x0)&&(temp_ch!='\r')) 
			     kb_ptr->Store_buf(temp_ch);
                     }
                   }

	        cprintf(" %c%c",ch,ch); 
                display_cursor();
                return;
                }

	if (UL_case==0)	ch=toupper(ch);

	current_window = activate_window(3);
        if(wherex()>=MAX_LINE)
	   if((ch==' ')||(wherex()>=LINE_OVERFLOW))
		{
		kb_ptr->Store_buf('\r');
		kb_ptr->Store_buf('\n');
		cprintf(" ");  		// to blank out old cursor
		cprintf("\r\n");
		clreol();
		entered_space+=1;  	// update for word mode
                if(ch==' ') {
			display_cursor(); // ignore the space char
			return;
			}
		}

// When in UPPER case mode, '$' is an illegal character - to send it
// ALT-W must be used. When in Upper/lower case mode, '$'= null figs 4
// There are also further special characters that is not defined in the
// ITA2 alphabet. 

	if(UL_case==0) switch(ch) {
		case '$': return;
		case '~': return;
		case '`': return;
		case '!': return;
		case '^': return;
		case '&': return;
		case '_': return;
		case '{': return;
		case '}': return;
		case '[': return;
		case ']': return;
		case 0x5c: return;
		case '|': return;
		case 0x22: return;
		case '<': return;
		case '>': return;
		case ';': return;
		default: extend_ascii(kb_ptr, ch); // save in buffer
		}
	else extend_ascii(kb_ptr, ch);  //  Extend & save in buffer

	if(ch=='\r') cprintf(" ");	// blank out old cursor

	cprintf("%c",ch);

	if(ch=='\r') 	       		// CR implies CR/LF
		{
		kb_ptr->Store_buf('\n');
		cprintf("\n");
		clreol();
		entered_space++;	// update word mode
		}

	display_cursor();
}
//----------------------------------------------------------------------------
void init_scrolling()
{
void scroll_display(int);
void do_scrolling();
int i;
char ch;

int bufsize, left=1,right=80,top=3, bottom, x, y;
char *tbuffer;

	bottom=window_boundary-1;
// Save cursur locations for screen 2  
	current_window = activate_window(2);  
	x=wherex(); y=wherey();

   	_setcursortype( _NORMALCURSOR );
        bufsize=2*(bottom-top+1)*(right-left+1);      // allocate buffer space
        if((tbuffer=(char *)malloc(bufsize))==NULL)
                terminate_prog("Malloc - allocating buffer");
        if(!gettext(left,top,right,bottom,tbuffer))   // copy existing data
                terminate_prog("Gettext - saving text!");

// define window for menu and display menu

        window(left,top,right,bottom);
	scrollines=window_boundary-3;

//
// Perform scrolling as required
//	
//	textbackground(LIGHTGRAY); 	 // Scrollback screen colors
//	textcolor(c_YELLOW);
	do_scrolling();
//	textbackground(c_BGCOLOR); // Default screen colors
//	textcolor(c_CHCOLOR);

	fclose(scrollfile);

//
// Re-open the scrollback ramdiskfile
//
	if((scrollfile=fopen(scrollback,"a+"))==NULL)
		{
		printf("Could not open the scrollback ramdisk file: <%s>\n", scrollback);
		printf("A serious failure has ocurred - please quit the program\n");
		strcpy(scrollback,"scroll.tmp");
		}

        if(!puttext(left,top,right,bottom,tbuffer))
                terminate_prog("Puttext - restoring text");

        free(tbuffer);
	textcolor(c_CHCOLOR);
	textbackground(c_BGCOLOR); 
   	_setcursortype( _NOCURSOR );

// Restore cursors
	current_window = activate_window(2);  
	gotoxy(x,y);			// leave cursor as before interrupted
}

//----------------------------------------------------------------------------

void do_scrolling()
//
// Get user's scrolling requests PgUp/PgDn//
// quit with any other character
//
{
void scroll_display(int);

int i;
char ch;

     	line_pointer=current-scrollines+1;
     	scroll_display(line_pointer);

	for(;;) {
		ch=getch();	// get response
         	if (ch == 0) {                /* 0 code */
            		ch = getch();
            		switch ( ch ) {
				case DownArrow:if(line_pointer+scrollines>current) break;
				     line_pointer++;
				     scroll_display(line_pointer);
				     break;
				case UpArrow:if(line_pointer<=0) break;
				     line_pointer--;
				     scroll_display(line_pointer);
				     break;
				case PgDn:if(line_pointer+2*scrollines+1>=current) break;
				     line_pointer+=scrollines;
				     scroll_display(line_pointer);
				     break;
				case PgUp:if(line_pointer-scrollines<=0) break;
				     line_pointer-=scrollines;
				     scroll_display(line_pointer);
				     break;
				case Home:
				     line_pointer=current-scrollines;
				     scroll_display(line_pointer);
				     break;
				case End:
				     return;
				default: return;
				}
			}
		else return;
		}
}
//----------------------------------------------------------------------------
void scroll_display(int start_line)
{
int line, i;
char ch;

	clrscr();
	for(line=0;line<scrollines;line++) {
		if(start_line+line<0) continue;
		gotoxy(1,line+1);
		if((fsetpos(scrollfile,&scroll_buffer[start_line+line]))!=0)
			printf("setpos failed");
		for(i=0;i<SCROLCOLS;i++) {
			ch=fgetc(scrollfile);
			if(ch==EOF) return;
			if(ch=='\0') break;
			if(ch=='\n') break;
			if(ch&0x80) {
				textattr(0x7F&(c_ECHOCOLOR+(c_BGCOLOR<<4)));
				cprintf("%c",ch&0x7F);
				textcolor(c_CHCOLOR);
				}
			else	cprintf("%c",ch);
			}
		}
}
//--------------------------------------------------------------------------
// Update scrolling file
//--------------------------------------------------------------------------
void update_scroll(char ch)
{
	if(ch=='\n') {
		fprintf(scrollfile,"\n");
		if(current>=SCROLLMAX-1) {
			movmem(&scroll_buffer[1],
			       &scroll_buffer[0],
			       (SCROLLMAX-1)*sizeof(fpos_t));	// buffer len
			fgetpos(scrollfile,&scroll_buffer[SCROLLMAX-1]);
			return;
			}
		fgetpos(scrollfile,scroll_ptr++);
		current++;
		return;			
		}
}	

