#define SIZ_BUF       1024	        // Keyboard buffer size
#define SM_SIZ_BUF    1024              // Special aux buffer size
#define ID_LENGTH	20		// Max length for user selcal 
#define SELCAL_LENGTH	20		// Max length for remote selcal
#define WRU_LENGTH	80		// Max length for remote selcal
#define LOGFILENAME_LENGTH 40		// Max logfilename length
 
#define DEFAULT_TXDELAY 30              // default tx delay
#define DEFAULT_USPEED  100             // default Unproto speed
#define DEFAULT_UREPEAT 2             	// default Unproto repeat count
#define DEFAULT_TXMASK   0              // default output bit mask
#define DEFAULT_RXMASK   0              // default input  bit mask
#define DEFAULT_TIMING   16000		// default timing sequence
#define DEFAULT_BGCOLOR  1              // blue background
#define DEFAULT_CHCOLOR  7              // light gray characters
#define DEFAULT_BOUNDARY 20		// Rx/Tx display boundary
#define DEFAULT_UOS      0              // UOS off
#define DEFAULT_CASE	 0		// disable case translations
#define DEFAULT_LOGOPTION 1		// logging text to file = on
#define DEFAULT_RELY     0		// disable high reliability option
#define DEFAULT_VIDEO    1		// Use direct video calls
#define DEFAULT_FILECRLF 1		// strip CR, NL=(CR+LF)
#define DEFAULT_REFRESH  10L 		// Status refresh rate
#define DEFAULT_OP_MODE  0 		// AMTOR
#define DEFAULT_BAUDRATE 45 		// Baudrate
#define DEFAULT_TIME_TYPE 0		// Use local time (set TZ=PST8)
#define GMT	 	 1		//
#define DEFAULT_DISPLAY  0		// Do not use analog tuning display
#define DEFAULT_WORD_MODE 1		// Use word mode
#define DEFAULT_MEM_ARQ   0		// Disable memory ARQ
#define MAX_COM	 	  4		// COM 1-4
#define DEFAULT_COM_PORT  1		// COM 1
#define DEFAULT_OLVL      56		// Sound out level
#define DEFAULT_ILVL      7		// Sound in  level
#define DEFAULT_COMBASE	  0x3F8		// Default COM port base address
#define DEFAULT_IRQ 	  4		// Default COM port interrupt
#define DEFAULT_PACTR_MDM 4		// PacTOR modem

#define AMT		0 		// Operating modes
#define BDOT		1
#define ASCI		2

#define RED              4		// red
#define GREEN	         2		// green
#define BLACK            0		// black
#define LIGHT_GRAY       7		// light gray
#define BLINK	       128              // blink attribute
#define LINE_OVERFLOW   76              // abs max characters on a line
#define MAX_LINE        68              // after this start looking for space
#define RX_LINE_OVERFLOW 80
#define BITSLIP        128              // max bit accumulated error bitph.
#define MAX_DELAY       50              // max allowable txdelay
//#define ID_LEN           8              // signiture length
#define MAX_BUFFERS     10              // maximum number of message buffers
//#define TORBIOS_INTR  0x60              // PCTOR software interrupt address
//#define TORBIOS_INTR  0x14              // PAMS software interrupt address
#define ARQ		55              // Mode
#define STBY	        00      
#define FEC             22
#define LISN            11
#define LOGINT		5		// Set for 5 minute intervals
#define SW_INT		10		// Set for 10 minute intervals

#define TAB		0x09
#define CTL_z		0x1A
#define SHIFT_TAB           15
#define ALT_Q               16
#define ALT_W               17
#define ALT_E               18
#define ALT_R               19
#define ALT_T               20
#define ALT_Y               21
#define ALT_U               22
#define ALT_I               23
#define ALT_O               24
#define ALT_P               25
#define ALT_A               30
#define ALT_S               31
#define ALT_D               32
#define ALT_F               33
#define ALT_G               34
#define ALT_H               35
#define ALT_J               36
#define ALT_K               37
#define ALT_L               38
#define ALT_Z               44
#define ALT_X               45
#define ALT_C               46
#define ALT_V               47
#define ALT_B               48
#define ALT_N               49
#define ALT_M               50
#define F1                  59
#define F2                  60
#define F3                  61
#define F4                  62
#define F5                  63
#define F6                  64
#define F7                  65
#define F8                  66
#define F9                  67
#define F10                 68
#define Home                71
#define UpArrow             72
#define PgUp                73
#define LeftArrow           75
#define RightArrow          77
#define End                 79
#define DownArrow           80
#define PgDn                81
#define Insert              82
#define Delete              83
#define SHIFT_F1            84
#define SHIFT_F2            85
#define SHIFT_F3            86
#define SHIFT_F4            87
#define SHIFT_F5            88
#define SHIFT_F6            89
#define SHIFT_F7            90
#define SHIFT_F8            91
#define SHIFT_F9            92
#define SHIFT_F10           93
#define CONTROL_F1          94
#define CONTROL_F2          95
#define CONTROL_F3          96
#define CONTROL_F4          97
#define CONTROL_F5          98
#define CONTROL_F6          99
#define CONTROL_F7         100
#define CONTROL_F8         101
#define CONTROL_F9         102
#define CONTROL_F10        103
#define ALT_F1             104
#define ALT_F2             105
#define ALT_F3             106
#define ALT_F4             107
#define ALT_F5             108
#define ALT_F6             109
#define ALT_F7             110
#define ALT_F8             111
#define ALT_F9             112
#define ALT_F10            113
#define CONTROL_PrtSc      114
#define CONTROL_LeftArrow  115
#define CONTROL_RightArrow 116
#define CONTROL_End        117
#define CONTROL_PgDn       118
#define CONTROL_Home       119
#define ALT_1              120
#define ALT_2              121
#define ALT_3              122
#define ALT_4              123
#define ALT_5              124
#define ALT_6              125
#define ALT_7              126
#define ALT_8              127
#define ALT_9              128
#define ALT_0              129
#define ALT_Hyphen         130
#define ALT_EQ             131
#define CONTROL_PgUp       132
#define BackSpace            8

#define NOIRQ		0x0000
#define IRQ3		0x0008
#define IRQ5		0x0010
#define IRQ7		0x0018
#define IRQ9		0x0020
#define IRQ10		0x0028
#define IRQ11       	0x0030
#define IRQ12		0x0038

